#include <tos.h>
#include <mt_aes.h>

typedef struct
{
	_WORD	control[5];
	_WORD	intin[AES_INTINMAX];
	_WORD	intout[AES_INTOUTMAX];
	void	*addrin[AES_ADDRINMAX];
	void	*addrout[AES_ADDROUTMAX];
} MT_PARMDATA;


void _aes_trap(MT_PARMDATA *aes_params, const _WORD *control, _WORD *global_aes);


static _WORD const aes_control_data[][4] = {
	{ 10, 0, 1, 0 }, /* 0 */
	{ 11, 2, 1, 1 }, /* 1 */
	{ 12, 2, 1, 1 }, /* 2 */
	{ 13, 0, 1, 1 }, /* 3 */
	{ 14, 2, 1, 1 }, /* 4 */
	{ 15, 1, 1, 1 }, /* 5 */
	{ 17, 0, 1, 0 }, /* 6 */
	{ 18, 0, 1, 0 }, /* 7 */
	{ 19, 0, 1, 0 }, /* 8 */
	{ 130, 1, 5, 0 }, /* 9 */
	{ 20, 0, 1, 0 }, /* 10 */
	{ 21, 3, 5, 0 }, /* 11 */
	{ 22, 5, 5, 0 }, /* 12 */
	{ 23, 0, 1, 1 }, /* 13 */
	{ 24, 2, 1, 0 }, /* 14 */
	{ 25, 16, 7, 1 }, /* 15 */
	{ 25, 16, 7, 1 }, /* 16 */
	{ 26, 2, 1, 0 }, /* 17 */
	{ 30, 1, 1, 1 }, /* 18 */
	{ 31, 2, 1, 1 }, /* 19 */
	{ 32, 2, 1, 1 }, /* 20 */
	{ 33, 2, 1, 1 }, /* 21 */
	{ 34, 1, 1, 2 }, /* 22 */
	{ 35, 1, 1, 1 }, /* 23 */
	{ 36, 1, 1, 0 }, /* 24 */
	{ 36, 2, 1, 2 }, /* 25 */
	{ 37, 2, 1, 0 }, /* 26 */
	{ 37, 2, 1, 2 }, /* 27 */
	{ 38, 3, 1, 1 }, /* 28 */
	{ 39, 1, 1, 1 }, /* 29 */
	{ 40, 2, 1, 1 }, /* 30 */
	{ 41, 1, 1, 1 }, /* 31 */
	{ 42, 6, 1, 1 }, /* 32 objc_draw */
	{ 43, 4, 1, 1 }, /* 33 */
	{ 44, 1, 3, 1 }, /* 34 objc_offset */
	{ 45, 2, 1, 1 }, /* 35 */
	{ 46, 4, 2, 1 }, /* 36 */
	{ 46, 4, 2, 2 }, /* 37 */
	{ 47, 8, 1, 1 }, /* 38 */
	{ 48, 4, 3, 0 }, /* 39 */
	{ 50, 1, 1, 1 }, /* 40 */
	{ 50, 1, 2, 3 }, /* 41 */
	{ 51, 9, 1, 0 }, /* 42 */
	{ 51, 9, 1, 2 }, /* 43 */
	{ 52, 1, 1, 1 }, /* 44 form_alert */
	{ 53, 1, 1, 0 }, /* 45 */
	{ 54, 0, 5, 1 }, /* 46 */
	{ 55, 3, 3, 1 }, /* 47 */
	{ 56, 2, 2, 1 }, /* 48 */
	{ 60, 3, 0, 2 }, /* 49 */
	{ 61, 3, 0, 2 }, /* 50 */
	{ 62, 4, 1, 1 }, /* 51 */
	{ 63, 3, 2, 1 }, /* 52 */
	{ 64, 3, 3, 1 }, /* 53 */
	{ 65, 5, 2, 1 }, /* 54 */
	{ 70, 4, 3, 0 }, /* 55 */
	{ 71, 8, 3, 0 }, /* 56 */
	{ 72, 6, 1, 0 }, /* 57 */
	{ 73, 8, 1, 0 }, /* 58 */
	{ 74, 8, 1, 0 }, /* 59 */
	{ 75, 4, 1, 1 }, /* 60 */
	{ 76, 3, 1, 1 }, /* 61 */
	{ 77, 0, 5, 0 }, /* 62 */
	{ 77, 0, 6, 0 }, /* 63 */
	{ 78, 1, 1, 1 }, /* 64 graf_mouse */
	{ 79, 0, 5, 0 }, /* 65 graf_mkstate */
	{ 80, 0, 1, 1 }, /* 66 */
	{ 81, 0, 1, 1 }, /* 67 */
	{ 82, 0, 1, 0 }, /* 68 */
	{ 90, 0, 2, 2 }, /* 69 */
	{ 91, 0, 2, 3 }, /* 70 */
	{ 100, 5, 1, 0 }, /* 71 */
	{ 101, 5, 1, 0 }, /* 72 */
	{ 102, 1, 1, 0 }, /* 73 */
	{ 103, 1, 1, 0 }, /* 74 */
	{ 104, 3, 5, 0 }, /* 75 wind_get */
	{ 104, 2, 5, 0 }, /* 76 wind_get */
	{ 104, 2, 5, 0 }, /* 77 wind_get */
	{ 104, 2, 5, 0 }, /* 78 wind_get */
	{ 105, 6, 1, 0 }, /* 79 wind_set */
	{ 105, 4, 1, 0 }, /* 80 wind_set */
	{ 105, 6, 1, 0 }, /* 81 wind_set */
	{ 105, 4, 1, 0 }, /* 82 wind_set */
	{ 105, 4, 1, 0 }, /* 83 wind_set */
	{ 106, 2, 1, 0 }, /* 84 */
	{ 107, 1, 1, 0 }, /* 85 */
	{ 108, 6, 5, 0 }, /* 86 */
	{ 109, 0, 0, 0 }, /* 87 */
	{ 110, 0, 1, 1 }, /* 88 */
	{ 111, 0, 1, 0 }, /* 89 */
	{ 112, 2, 1, 0 }, /* 90 */
	{ 113, 2, 1, 1 }, /* 91 */
	{ 114, 1, 1, 1 }, /* 92 */
	{ 115, 0, 1, 1 }, /* 93 */
	{ 120, 0, 1, 2 }, /* 94 */
	{ 121, 3, 1, 2 }, /* 95 */
	{ 122, 1, 1, 1 }, /* 96 */
	{ 123, 1, 1, 1 }, /* 97 */
	{ 124, 0, 1, 1 }, /* 98 */
	{ 125, 0, 1, 2 }, /* 99 */
	{ 126, 0, 1, 2 }, /* 100 */
	{ 127, 0, 1, 2 }, /* 101 */
	{ 135, 2, 1, 1 }, /* 102 */
	{ 135, 6, 2, 3 }, /* 103 */
	{ 136, 2, 1, 1 }, /* 104 */
	{ 160, 2, 0, 4 }, /* 105 */
	{ 161, 4, 1, 3 }, /* 106 */
	{ 162, 0, 3, 1 }, /* 107 */
	{ 163, 0, 1, 1 }, /* 108 */
	{ 164, 1, 1, 3 }, /* 109 */
	{ 164, 1, 2, 1 }, /* 110 */
	{ 164, 1, 0, 1 }, /* 111 */
	{ 164, 1, 1, 1 }, /* 112 */
	{ 165, 2, 1, 1 }, /* 113 */
	{ 165, 1, 1, 2 }, /* 114 */
	{ 165, 1, 1, 2 }, /* 115 */
	{ 165, 2, 1, 4 }, /* 116 */
	{ 165, 1, 1, 4 }, /* 117 */
	{ 166, 0, 1, 2 }, /* 118 */
	{ 167, 2, 0, 2 }, /* 119 */
	{ 170, 8, 0, 8 }, /* 120 */
	{ 171, 0, 0, 2 }, /* 121 */
	{ 172, 1, 1, 1 }, /* 122 */
	{ 173, 0, 1, 1 }, /* 123 */
	{ 174, 1, 1, 1 }, /* 124 */
	{ 174, 1, 0, 1 }, /* 125 */
	{ 174, 1, 1, 1 }, /* 126 */
	{ 174, 1, 0, 1 }, /* 127 */
	{ 174, 1, 1, 1 }, /* 128 */
	{ 174, 1, 1, 1 }, /* 129 */
	{ 174, 1, 0, 1 }, /* 130 */
	{ 174, 2, 0, 1 }, /* 131 */
	{ 174, 1, 0, 1 }, /* 132 */
	{ 174, 1, 1, 2 }, /* 133 */
	{ 174, 1, 1, 1 }, /* 134 */
	{ 174, 1, 1, 1 }, /* 135 */
	{ 174, 1, 1, 1 }, /* 136 */
	{ 175, 2, 0, 2 }, /* 137 */
	{ 175, 1, 0, 2 }, /* 138 */
	{ 175, 1, 0, 1 }, /* 139 */
	{ 175, 1, 0, 1 }, /* 140 */
	{ 175, 2, 0, 3 }, /* 141 */
	{ 175, 2, 0, 2 }, /* 142 */
	{ 175, 2, 0, 1 }, /* 143 */
	{ 175, 2, 0, 3 }, /* 144 */
	{ 180, 4, 0, 4 }, /* 145 */
	{ 181, 1, 1, 1 }, /* 146 */
	{ 182, 9, 1, 1 }, /* 147 */
	{ 183, 0, 3, 1 }, /* 148 */
	{ 184, 3, 1, 1 }, /* 149 */
	{ 184, 4, 1, 1 }, /* 150 */
	{ 184, 3, 1, 4 }, /* 151 */
	{ 184, 3, 0, 1 }, /* 152 */
	{ 185, 1, 1, 2 }, /* 153 */
	{ 185, 1, 0, 1 }, /* 154 */
	{ 185, 8, 1, 1 }, /* 155 */
	{ 186, 0, 9, 2 }, /* 156 */
	{ 187, 7, 0, 1 }, /* 157 */
	{ 190, 6, 1, 6 }, /* 158 */
	{ 191, 0, 1, 1 }, /* 159 */
	{ 192, 0, 1, 2 }, /* 160 */
	{ 193, 0, 4, 4 }, /* 161 */
	{ 194, 4, 4, 6 }, /* 162 */
	{ 195, 2, 2, 0 }, /* 163 */
	{ 200, 1, 0, 0 }, /* 164 */
	{ 201, 0, 1, 1 }, /* 165 */
	{ 202, 3, 1, 3 }, /* 166 */
	{ 203, 0, 3, 1 }, /* 167 */
	{ 204, 1, 2, 0 }, /* 168 */
	{ 205, 1, 1, 2 }, /* 169 */
	{ 205, 1, 1, 1 }, /* 170 */
	{ 205, 1, 1, 3 }, /* 171 */
	{ 205, 1, 1, 2 }, /* 172 */
	{ 205, 1, 1, 1 }, /* 173 */
	{ 205, 1, 0, 1 }, /* 174 */
	{ 205, 1, 1, 1 }, /* 175 */
	{ 205, 1, 1, 2 }, /* 176 */
	{ 205, 1, 1, 2 }, /* 177 */
	{ 205, 1, 1, 2 }, /* 178 */
	{ 205, 1, 1, 2 }, /* 179 */
	{ 206, 0, 2, 3 }, /* 180 */
	{ 207, 1, 1, 3 }, /* 181 */
	{ 210, 0, 0, 0 }, /* 182 */
	{ 211, 1, 1, 1 }, /* 183 */
	{ 212, 1, 0, 1 }, /* 184 */
	{ 213, 0, 0, 1 }, /* 185 */
	{ 214, 3, 1, 1 }, /* 186 */
	{ 215, 2, 3, 2 }, /* 187 */
	{ 216, 2, 5, 1 }, /* 188 */
	{ 216, 2, 3, 1 }, /* 189 */
	{ 216, 2, 3, 1 }, /* 190 */
	{ 216, 2, 5, 1 }, /* 191 */
	{ 216, 2, 1, 1 }, /* 192 */
	{ 216, 2, 6, 1 }, /* 193 */
	{ 216, 2, 1, 1 }, /* 194 */
	{ 216, 2, 0, 1 }, /* 195 */
	{ 216, 2, 6, 1 }, /* 196 */
	{ 217, 4, 0, 2 }, /* 197 */
	{ 217, 4, 0, 1 }, /* 198 */
	{ 217, 4, 0, 1 }, /* 199 */
	{ 217, 6, 0, 1 }, /* 200 */
	{ 217, 2, 0, 2 }, /* 201 */
	{ 217, 7, 0, 3 }, /* 202 */
	{ 217, 2, 3, 1 }, /* 203 */
	{ 217, 2, 0, 2 }, /* 204 */
	{ 217, 6, 1, 1 }, /* 205 */
	
};



_WORD mt_objc_draw_grect(OBJECT *tree, _WORD start, _WORD depth, const GRECT *r, WORD *global_aes)
{
	MT_PARMDATA aes_params;
	
	aes_params.intin[0] = start;
	aes_params.intin[1] = depth;
	*(GRECT *)&aes_params.intin[2] = *r;
	aes_params.addrin[0] = tree;
	
	_aes_trap(&aes_params, aes_control_data[32], global_aes);
	return aes_params.intout[0];
}


_WORD mt_objc_offset(OBJECT *tree, _WORD object, _WORD *x, _WORD *y, _WORD *global_aes)
{
	MT_PARMDATA aes_params;
	
	aes_params.intin[0] = object;
	aes_params.addrin[0] = tree;
	
	_aes_trap(&aes_params, aes_control_data[34], global_aes);
	*x = aes_params.intout[1];
	*y = aes_params.intout[2];
	return aes_params.intout[0];
}


_WORD mt_form_alert(_WORD fo_adefbttn, const char *fo_astring, _WORD *global_aes)
{
	MT_PARMDATA aes_params;
	
	aes_params.intin[0] = fo_adefbttn;
	aes_params.addrin[0] = fo_astring;
	
	_aes_trap(&aes_params, aes_control_data[44], global_aes);
	return aes_params.intout[0];
}


WORD mt_graf_mouse(WORD gr_monumber, const MFORM *gr_mofaddr, WORD *global_aes)
{
	MT_PARMDATA aes_params;
	
	aes_params.intin[0] = gr_monumber;
	aes_params.addrin[0] = gr_mofaddr;
	
	_aes_trap(&aes_params, aes_control_data[64], global_aes);
	return aes_params.intout[0];
}


WORD mt_graf_mkstate_event(EVNTDATA *data, WORD *global_aes)
{
	MT_PARMDATA aes_params;
	
	_aes_trap(&aes_params, aes_control_data[65], global_aes);
	*data = *((EVNTDATA *)&aes_params.intout[1]);
	return aes_params.intout[0];
}


WORD mt_wind_get(WORD whdl, WORD subfn, WORD *g1, WORD *g2, WORD *g3, WORD *g4, WORD *global_aes)
{
	MT_PARMDATA aes_params;
	
	aes_params.intin[0] = whdl;
	aes_params.intin[1] = subfn;
	_aes_trap(&aes_params, aes_control_data[75], global_aes);
	if (g1)
		*g1 = aes_params.intout[1];
	if (g2)
		*g2 = aes_params.intout[2];
	if (g3)
		*g3 = aes_params.intout[3];
	if (g4)
		*g4 = aes_params.intout[4];
	return aes_params.intout[0];
}
